Bug 176645 - Error should compute .stack and friends lazily
Summary: Error should compute .stack and friends lazily
Status: RESOLVED FIXED
Alias: None
Product: WebKit
Classification: Unclassified
Component: JavaScriptCore (show other bugs)
Version: WebKit Nightly Build
Hardware: All All
: P2 Normal
Assignee: Filip Pizlo
URL:
Keywords: InRadar
Depends on:
Blocks:
 
Reported: 2017-09-08 21:32 PDT by Filip Pizlo
Modified: 2017-09-27 12:36 PDT (History)
13 users (show)

See Also:


Attachments
possible patch (18.08 KB, patch)
2017-09-08 21:33 PDT, Filip Pizlo
no flags Details | Formatted Diff | Diff
the patch (21.57 KB, patch)
2017-09-08 22:15 PDT, Filip Pizlo
no flags Details | Formatted Diff | Diff
the patch (21.57 KB, patch)
2017-09-08 22:35 PDT, Filip Pizlo
sbarati: review+
buildbot: commit-queue-
Details | Formatted Diff | Diff
Archive of layout-test-results from ews100 for mac-elcapitan (1.27 MB, application/zip)
2017-09-08 23:41 PDT, Build Bot
no flags Details
Archive of layout-test-results from ews106 for mac-elcapitan-wk2 (1.31 MB, application/zip)
2017-09-08 23:49 PDT, Build Bot
no flags Details
Archive of layout-test-results from ews125 for ios-simulator-wk2 (1.51 MB, application/zip)
2017-09-09 00:26 PDT, Build Bot
no flags Details
possible patch for landing (22.93 KB, patch)
2017-09-09 12:23 PDT, Filip Pizlo
buildbot: commit-queue-
Details | Formatted Diff | Diff
Archive of layout-test-results from ews100 for mac-elcapitan (1.25 MB, application/zip)
2017-09-09 13:32 PDT, Build Bot
no flags Details
Archive of layout-test-results from ews105 for mac-elcapitan-wk2 (1.35 MB, application/zip)
2017-09-09 13:38 PDT, Build Bot
no flags Details
Archive of layout-test-results from ews112 for mac-elcapitan (1.34 MB, application/zip)
2017-09-09 13:50 PDT, Build Bot
no flags Details
possible patch for landing (23.45 KB, patch)
2017-09-09 13:55 PDT, Filip Pizlo
buildbot: commit-queue-
Details | Formatted Diff | Diff
Archive of layout-test-results from ews102 for mac-elcapitan (1.25 MB, application/zip)
2017-09-09 15:04 PDT, Build Bot
no flags Details
Archive of layout-test-results from ews105 for mac-elcapitan-wk2 (1.31 MB, application/zip)
2017-09-09 15:09 PDT, Build Bot
no flags Details
Archive of layout-test-results from ews116 for mac-elcapitan (1.34 MB, application/zip)
2017-09-09 15:18 PDT, Build Bot
no flags Details
Archive of layout-test-results from ews122 for ios-simulator-wk2 (1.47 MB, application/zip)
2017-09-09 15:47 PDT, Build Bot
no flags Details
possible patch for landing (33.22 KB, patch)
2017-09-09 18:50 PDT, Filip Pizlo
buildbot: commit-queue-
Details | Formatted Diff | Diff
Archive of layout-test-results from ews103 for mac-elcapitan (1.43 MB, application/zip)
2017-09-09 20:12 PDT, Build Bot
no flags Details
Archive of layout-test-results from ews105 for mac-elcapitan-wk2 (1.52 MB, application/zip)
2017-09-09 20:16 PDT, Build Bot
no flags Details
Archive of layout-test-results from ews116 for mac-elcapitan (2.18 MB, application/zip)
2017-09-09 20:34 PDT, Build Bot
no flags Details
Archive of layout-test-results from ews125 for ios-simulator-wk2 (1.29 MB, application/zip)
2017-09-09 20:40 PDT, Build Bot
no flags Details
possible patch for landing (35.20 KB, patch)
2017-09-09 20:52 PDT, Filip Pizlo
buildbot: commit-queue-
Details | Formatted Diff | Diff
Archive of layout-test-results from ews100 for mac-elcapitan (1.29 MB, application/zip)
2017-09-09 22:03 PDT, Build Bot
no flags Details
Archive of layout-test-results from ews105 for mac-elcapitan-wk2 (1.35 MB, application/zip)
2017-09-09 22:06 PDT, Build Bot
no flags Details
Archive of layout-test-results from ews115 for mac-elcapitan (1.35 MB, application/zip)
2017-09-09 22:16 PDT, Build Bot
no flags Details
Archive of layout-test-results from ews125 for ios-simulator-wk2 (1.23 MB, application/zip)
2017-09-09 22:31 PDT, Build Bot
no flags Details
possible patch for landing (34.48 KB, patch)
2017-09-10 09:59 PDT, Filip Pizlo
no flags Details | Formatted Diff | Diff
possible patch for landing (35.10 KB, patch)
2017-09-10 11:03 PDT, Filip Pizlo
no flags Details | Formatted Diff | Diff

Note You need to log in before you can comment on or make changes to this bug.
Description Filip Pizlo 2017-09-08 21:32:44 PDT
Patch forthcoming.
Comment 1 Filip Pizlo 2017-09-08 21:33:44 PDT
Created attachment 320331 [details]
possible patch

I haven't tried compiling it yet.
Comment 2 Filip Pizlo 2017-09-08 22:15:17 PDT
Created attachment 320332 [details]
the patch
Comment 3 Filip Pizlo 2017-09-08 22:35:31 PDT
Created attachment 320335 [details]
the patch

Updated patch.

I'm pretty sure this will have WebCore build errors.  But I'll put it up anyway while I run some benchmarks.
Comment 4 Saam Barati 2017-09-08 22:47:15 PDT
Comment on attachment 320335 [details]
the patch

View in context: https://bugs.webkit.org/attachment.cgi?id=320335&action=review

> Source/JavaScriptCore/ChangeLog:12
> +        This is an enormous speed-up for programs that allocate and throw exceptions.

Awesome

> Source/JavaScriptCore/runtime/Error.cpp:41
> +#include "SuperSampler.h"

Please remove it doesn’t look like it’s used

> Source/JavaScriptCore/runtime/ErrorInstance.cpp:29
> +#include "SuperSampler.h"

Please remove it doesn’t look like it’s used
Comment 5 Saam Barati 2017-09-08 22:48:41 PDT
Comment on attachment 320335 [details]
the patch

View in context: https://bugs.webkit.org/attachment.cgi?id=320335&action=review

> Source/JavaScriptCore/runtime/Error.cpp:-184
> -        if (bytecodeOffset) {

This is no longer needed?
Comment 6 Build Bot 2017-09-08 23:22:17 PDT
Comment on attachment 320335 [details]
the patch

Attachment 320335 [details] did not pass jsc-ews (mac):
Output: http://webkit-queues.webkit.org/results/4494093

New failing tests:
stress/error-stack-trace-limit.js.no-llint
stress/error-stack-trace-limit.js.ftl-no-cjit-small-pool
stress/error-stack-trace-limit.js.ftl-no-cjit-b3o1
ChakraCore.yaml/ChakraCore/test/StackTrace/ErrorDotStackAlreadyExists.js.default
stress/error-stack-trace-limit.js.ftl-no-cjit-no-put-stack-validate
stress/error-stack-trace-limit.js.ftl-eager-no-cjit
stress/error-stack-trace-limit.js.ftl-eager-no-cjit-b3o1
stress/error-stack-trace-limit.js.default
stress/error-stack-trace-limit.js.no-cjit-validate-phases
stress/error-stack-trace-limit.js.ftl-eager
ChakraCore.yaml/ChakraCore/test/Error/NativeErrors.js.default
stress/error-stack-trace-limit.js.dfg-eager-no-cjit-validate
stress/error-stack-trace-limit.js.no-cjit-collect-continuously
stress/error-stack-trace-limit.js.no-ftl
stress/error-stack-trace-limit.js.dfg-eager
stress/error-stack-trace-limit.js.dfg-maximal-flush-validate-no-cjit
stress/error-stack-trace-limit.js.ftl-no-cjit-no-inline-validate
stress/error-stack-trace-limit.js.ftl-no-cjit-validate-sampling-profiler
Comment 7 Build Bot 2017-09-08 23:41:52 PDT
Comment on attachment 320335 [details]
the patch

Attachment 320335 [details] did not pass mac-ews (mac):
Output: http://webkit-queues.webkit.org/results/4494149

Number of test failures exceeded the failure limit.
Comment 8 Build Bot 2017-09-08 23:41:54 PDT
Created attachment 320337 [details]
Archive of layout-test-results from ews100 for mac-elcapitan

The attached test failures were seen while running run-webkit-tests on the mac-ews.
Bot: ews100  Port: mac-elcapitan  Platform: Mac OS X 10.11.6
Comment 9 Build Bot 2017-09-08 23:49:56 PDT
Comment on attachment 320335 [details]
the patch

Attachment 320335 [details] did not pass mac-wk2-ews (mac-wk2):
Output: http://webkit-queues.webkit.org/results/4494170

Number of test failures exceeded the failure limit.
Comment 10 Build Bot 2017-09-08 23:49:57 PDT
Created attachment 320338 [details]
Archive of layout-test-results from ews106 for mac-elcapitan-wk2

The attached test failures were seen while running run-webkit-tests on the mac-wk2-ews.
Bot: ews106  Port: mac-elcapitan-wk2  Platform: Mac OS X 10.11.6
Comment 11 Filip Pizlo 2017-09-09 00:05:44 PDT
(In reply to Saam Barati from comment #5)
> Comment on attachment 320335 [details]
> the patch
> 
> View in context:
> https://bugs.webkit.org/attachment.cgi?id=320335&action=review
> 
> > Source/JavaScriptCore/runtime/Error.cpp:-184
> > -        if (bytecodeOffset) {
> 
> This is no longer needed?

It's in getBytecodeOffset() now.
Comment 12 Build Bot 2017-09-09 00:26:28 PDT
Comment on attachment 320335 [details]
the patch

Attachment 320335 [details] did not pass ios-sim-ews (ios-simulator-wk2):
Output: http://webkit-queues.webkit.org/results/4494239

New failing tests:
imported/w3c/web-platform-tests/html/webappapis/scripting/processing-model-2/window-onerror-with-cross-frame-event-listeners-4.html
http/tests/security/contentSecurityPolicy/function-constructor-blocked.html
js/dom/parse-error-external-script-in-eval.html
fast/dom/NamedNodeMap-setNamedItem-crash.html
imported/w3c/web-platform-tests/html/webappapis/scripting/processing-model-2/window-onerror-with-cross-frame-event-listeners-1.html
fast/events/window-onerror-syntax-error-in-attr.html
imported/w3c/web-platform-tests/html/webappapis/scripting/processing-model-2/window-onerror-with-cross-frame-event-listeners-3.html
imported/w3c/web-platform-tests/streams/piping/error-propagation-forward.html
imported/w3c/web-platform-tests/html/webappapis/scripting/processing-model-2/window-onerror-with-cross-frame-event-listeners-2.html
http/tests/security/xss-DENIED-contentWindow-eval.html
http/tests/workers/worker-importScriptsOnError.html
imported/w3c/web-platform-tests/streams/piping/error-propagation-backward.html
js/dom/global-recursion-on-full-stack.html
fast/dom/Window/window-custom-prototype-crash.html
fast/dom/timer-clear-interval-in-handler-and-generate-error.html
imported/w3c/web-platform-tests/streams/piping/general.html
http/tests/security/contentSecurityPolicy/eval-blocked.html
fast/events/window-onerror5.html
http/tests/security/contentSecurityPolicy/module-eval-blocked.html
fast/events/window-onerror4.html
http/tests/security/contentSecurityPolicy/eval-blocked-in-subframe.html
http/tests/security/contentSecurityPolicy/eval-blocked-in-about-blank-iframe.html
js/dom/concat-large-strings-crash.html
http/tests/security/window-named-proto.html
http/tests/security/contentSecurityPolicy/eval-blocked-in-external-script.html
http/tests/security/contentSecurityPolicy/module-eval-blocked-in-external-script.html
Comment 13 Build Bot 2017-09-09 00:26:29 PDT
Created attachment 320339 [details]
Archive of layout-test-results from ews125 for ios-simulator-wk2

The attached test failures were seen while running run-webkit-tests on the ios-sim-ews.
Bot: ews125  Port: ios-simulator-wk2  Platform: Mac OS X 10.12.5
Comment 14 Filip Pizlo 2017-09-09 12:23:39 PDT
Created attachment 320351 [details]
possible patch for landing

Fixing various bugs.
Comment 15 Build Bot 2017-09-09 13:11:02 PDT
Comment on attachment 320351 [details]
possible patch for landing

Attachment 320351 [details] did not pass jsc-ews (mac):
Output: http://webkit-queues.webkit.org/results/4498497

New failing tests:
jsc-layout-tests.yaml/js/script-tests/exception-properties.js.layout-ftl-eager-no-cjit
jsc-layout-tests.yaml/js/script-tests/exception-properties.js.layout-ftl-no-cjit
ChakraCore.yaml/ChakraCore/test/StackTrace/ErrorDotStackAlreadyExists.js.default
ChakraCore.yaml/ChakraCore/test/Error/NativeErrors.js.default
jsc-layout-tests.yaml/js/script-tests/exception-properties.js.layout-dfg-eager-no-cjit
jsc-layout-tests.yaml/js/script-tests/exception-properties.js.layout
jsc-layout-tests.yaml/js/script-tests/exception-properties.js.layout-no-llint
jsc-layout-tests.yaml/js/script-tests/exception-properties.js.layout-no-cjit
jsc-layout-tests.yaml/js/script-tests/exception-properties.js.layout-no-ftl
Comment 16 Build Bot 2017-09-09 13:32:18 PDT
Comment on attachment 320351 [details]
possible patch for landing

Attachment 320351 [details] did not pass mac-ews (mac):
Output: http://webkit-queues.webkit.org/results/4498570

Number of test failures exceeded the failure limit.
Comment 17 Build Bot 2017-09-09 13:32:20 PDT
Created attachment 320354 [details]
Archive of layout-test-results from ews100 for mac-elcapitan

The attached test failures were seen while running run-webkit-tests on the mac-ews.
Bot: ews100  Port: mac-elcapitan  Platform: Mac OS X 10.11.6
Comment 18 Build Bot 2017-09-09 13:38:02 PDT
Comment on attachment 320351 [details]
possible patch for landing

Attachment 320351 [details] did not pass mac-wk2-ews (mac-wk2):
Output: http://webkit-queues.webkit.org/results/4498580

Number of test failures exceeded the failure limit.
Comment 19 Build Bot 2017-09-09 13:38:04 PDT
Created attachment 320355 [details]
Archive of layout-test-results from ews105 for mac-elcapitan-wk2

The attached test failures were seen while running run-webkit-tests on the mac-wk2-ews.
Bot: ews105  Port: mac-elcapitan-wk2  Platform: Mac OS X 10.11.6
Comment 20 Build Bot 2017-09-09 13:50:04 PDT
Comment on attachment 320351 [details]
possible patch for landing

Attachment 320351 [details] did not pass mac-debug-ews (mac):
Output: http://webkit-queues.webkit.org/results/4498587

Number of test failures exceeded the failure limit.
Comment 21 Build Bot 2017-09-09 13:50:06 PDT
Created attachment 320356 [details]
Archive of layout-test-results from ews112 for mac-elcapitan

The attached test failures were seen while running run-webkit-tests on the mac-debug-ews.
Bot: ews112  Port: mac-elcapitan  Platform: Mac OS X 10.11.6
Comment 22 Filip Pizlo 2017-09-09 13:55:50 PDT
Created attachment 320357 [details]
possible patch for landing

It took me a while to figure out exactly what to override if you want to handle for-in by materializing.
Comment 23 Filip Pizlo 2017-09-09 14:23:26 PDT
I think we can ignore the remaining JSC test failure, because it's a ChakraCore test that asserts that the stack property and its friends are in a particular order as observable by for-in. Because these are non-standard properties, I don't think we have to worry about this.
Comment 24 Filip Pizlo 2017-09-09 14:23:54 PDT
(In reply to Filip Pizlo from comment #23)
> I think we can ignore the remaining JSC test failure, because it's a
> ChakraCore test that asserts that the stack property and its friends are in
> a particular order as observable by for-in. Because these are non-standard
> properties, I don't think we have to worry about this.

(so I'll skip or modify the test.)
Comment 25 Build Bot 2017-09-09 14:44:55 PDT
Comment on attachment 320357 [details]
possible patch for landing

Attachment 320357 [details] did not pass jsc-ews (mac):
Output: http://webkit-queues.webkit.org/results/4498966

New failing tests:
ChakraCore.yaml/ChakraCore/test/StackTrace/ErrorDotStackAlreadyExists.js.default
Comment 26 Filip Pizlo 2017-09-09 14:45:51 PDT
Looks like I still have DOM exception issues.
Comment 27 Build Bot 2017-09-09 15:04:40 PDT
Comment on attachment 320357 [details]
possible patch for landing

Attachment 320357 [details] did not pass mac-ews (mac):
Output: http://webkit-queues.webkit.org/results/4499029

Number of test failures exceeded the failure limit.
Comment 28 Build Bot 2017-09-09 15:04:41 PDT
Created attachment 320361 [details]
Archive of layout-test-results from ews102 for mac-elcapitan

The attached test failures were seen while running run-webkit-tests on the mac-ews.
Bot: ews102  Port: mac-elcapitan  Platform: Mac OS X 10.11.6
Comment 29 Build Bot 2017-09-09 15:09:08 PDT
Comment on attachment 320357 [details]
possible patch for landing

Attachment 320357 [details] did not pass mac-wk2-ews (mac-wk2):
Output: http://webkit-queues.webkit.org/results/4499034

Number of test failures exceeded the failure limit.
Comment 30 Build Bot 2017-09-09 15:09:10 PDT
Created attachment 320362 [details]
Archive of layout-test-results from ews105 for mac-elcapitan-wk2

The attached test failures were seen while running run-webkit-tests on the mac-wk2-ews.
Bot: ews105  Port: mac-elcapitan-wk2  Platform: Mac OS X 10.11.6
Comment 31 Build Bot 2017-09-09 15:18:31 PDT
Comment on attachment 320357 [details]
possible patch for landing

Attachment 320357 [details] did not pass mac-debug-ews (mac):
Output: http://webkit-queues.webkit.org/results/4499084

Number of test failures exceeded the failure limit.
Comment 32 Build Bot 2017-09-09 15:18:33 PDT
Created attachment 320363 [details]
Archive of layout-test-results from ews116 for mac-elcapitan

The attached test failures were seen while running run-webkit-tests on the mac-debug-ews.
Bot: ews116  Port: mac-elcapitan  Platform: Mac OS X 10.11.6
Comment 33 Build Bot 2017-09-09 15:47:22 PDT
Comment on attachment 320357 [details]
possible patch for landing

Attachment 320357 [details] did not pass ios-sim-ews (ios-simulator-wk2):
Output: http://webkit-queues.webkit.org/results/4499155

New failing tests:
imported/w3c/web-platform-tests/html/webappapis/scripting/processing-model-2/window-onerror-with-cross-frame-event-listeners-4.html
http/tests/security/contentSecurityPolicy/function-constructor-blocked.html
js/dom/parse-error-external-script-in-eval.html
fast/dom/NamedNodeMap-setNamedItem-crash.html
imported/w3c/web-platform-tests/html/webappapis/scripting/processing-model-2/window-onerror-with-cross-frame-event-listeners-1.html
fast/events/window-onerror-syntax-error-in-attr.html
imported/w3c/web-platform-tests/html/webappapis/scripting/processing-model-2/window-onerror-with-cross-frame-event-listeners-3.html
imported/w3c/web-platform-tests/streams/piping/error-propagation-forward.html
imported/w3c/web-platform-tests/html/webappapis/scripting/processing-model-2/window-onerror-with-cross-frame-event-listeners-2.html
http/tests/security/xss-DENIED-contentWindow-eval.html
http/tests/workers/worker-importScriptsOnError.html
imported/w3c/web-platform-tests/streams/piping/error-propagation-backward.html
js/dom/global-recursion-on-full-stack.html
fast/dom/Window/window-custom-prototype-crash.html
fast/dom/timer-clear-interval-in-handler-and-generate-error.html
imported/w3c/web-platform-tests/streams/piping/general.html
http/tests/security/contentSecurityPolicy/eval-blocked.html
fast/events/window-onerror5.html
http/tests/security/contentSecurityPolicy/module-eval-blocked.html
fast/events/window-onerror4.html
http/tests/security/contentSecurityPolicy/eval-blocked-in-subframe.html
http/tests/security/contentSecurityPolicy/eval-blocked-in-about-blank-iframe.html
js/dom/concat-large-strings-crash.html
http/tests/security/window-named-proto.html
http/tests/security/contentSecurityPolicy/eval-blocked-in-external-script.html
http/tests/security/contentSecurityPolicy/module-eval-blocked-in-external-script.html
Comment 34 Build Bot 2017-09-09 15:47:24 PDT
Created attachment 320364 [details]
Archive of layout-test-results from ews122 for ios-simulator-wk2

The attached test failures were seen while running run-webkit-tests on the ios-sim-ews.
Bot: ews122  Port: ios-simulator-wk2  Platform: Mac OS X 10.12.5
Comment 35 Filip Pizlo 2017-09-09 18:50:36 PDT
Created attachment 320371 [details]
possible patch for landing

Fixed more bugs.

There was code relying on being able to get the line/etc properties using getDirect.  That doesn't work if we're lazily materializing them.
Comment 36 Build Bot 2017-09-09 20:12:07 PDT
Comment on attachment 320371 [details]
possible patch for landing

Attachment 320371 [details] did not pass mac-ews (mac):
Output: http://webkit-queues.webkit.org/results/4500873

New failing tests:
userscripts/window-onerror-for-isolated-world-2.html
fast/events/window-onerror4.html
inspector/unit-tests/globals-uncaught-exception-from-timer-callback.html
userscripts/window-onerror-for-isolated-world-1.html
js/dom/parse-error-external-script-in-new-Function.html
fast/events/window-onerror-syntax-error-in-attr.html
inspector/debugger/setBreakpoint-options-exception.html
inspector/console/messageAdded-from-named-evaluations.html
Comment 37 Build Bot 2017-09-09 20:12:08 PDT
Created attachment 320372 [details]
Archive of layout-test-results from ews103 for mac-elcapitan

The attached test failures were seen while running run-webkit-tests on the mac-ews.
Bot: ews103  Port: mac-elcapitan  Platform: Mac OS X 10.11.6
Comment 38 Build Bot 2017-09-09 20:16:50 PDT
Comment on attachment 320371 [details]
possible patch for landing

Attachment 320371 [details] did not pass mac-wk2-ews (mac-wk2):
Output: http://webkit-queues.webkit.org/results/4500877

New failing tests:
fast/events/window-onerror4.html
inspector/unit-tests/globals-uncaught-exception-from-timer-callback.html
js/dom/parse-error-external-script-in-new-Function.html
fast/events/window-onerror-syntax-error-in-attr.html
inspector/debugger/setBreakpoint-options-exception.html
inspector/console/messageAdded-from-named-evaluations.html
Comment 39 Build Bot 2017-09-09 20:16:52 PDT
Created attachment 320373 [details]
Archive of layout-test-results from ews105 for mac-elcapitan-wk2

The attached test failures were seen while running run-webkit-tests on the mac-wk2-ews.
Bot: ews105  Port: mac-elcapitan-wk2  Platform: Mac OS X 10.11.6
Comment 40 Build Bot 2017-09-09 20:34:36 PDT
Comment on attachment 320371 [details]
possible patch for landing

Attachment 320371 [details] did not pass mac-debug-ews (mac):
Output: http://webkit-queues.webkit.org/results/4500882

New failing tests:
userscripts/window-onerror-for-isolated-world-2.html
fast/events/window-onerror4.html
inspector/unit-tests/globals-uncaught-exception-from-timer-callback.html
userscripts/window-onerror-for-isolated-world-1.html
js/dom/parse-error-external-script-in-new-Function.html
fast/events/window-onerror-syntax-error-in-attr.html
inspector/debugger/setBreakpoint-options-exception.html
inspector/console/messageAdded-from-named-evaluations.html
Comment 41 Build Bot 2017-09-09 20:34:38 PDT
Created attachment 320374 [details]
Archive of layout-test-results from ews116 for mac-elcapitan

The attached test failures were seen while running run-webkit-tests on the mac-debug-ews.
Bot: ews116  Port: mac-elcapitan  Platform: Mac OS X 10.11.6
Comment 42 Build Bot 2017-09-09 20:40:04 PDT
Comment on attachment 320371 [details]
possible patch for landing

Attachment 320371 [details] did not pass ios-sim-ews (ios-simulator-wk2):
Output: http://webkit-queues.webkit.org/results/4500918

New failing tests:
js/dom/parse-error-external-script-in-new-Function.html
fast/events/window-onerror4.html
fast/events/window-onerror-syntax-error-in-attr.html
Comment 43 Build Bot 2017-09-09 20:40:06 PDT
Created attachment 320375 [details]
Archive of layout-test-results from ews125 for ios-simulator-wk2

The attached test failures were seen while running run-webkit-tests on the ios-sim-ews.
Bot: ews125  Port: ios-simulator-wk2  Platform: Mac OS X 10.12.5
Comment 44 Filip Pizlo 2017-09-09 20:52:35 PDT
Created attachment 320377 [details]
possible patch for landing

Fixed a few random bugs in how the DOM now sees exceptions.
Comment 45 Build Bot 2017-09-09 22:03:08 PDT
Comment on attachment 320377 [details]
possible patch for landing

Attachment 320377 [details] did not pass mac-ews (mac):
Output: http://webkit-queues.webkit.org/results/4501478

Number of test failures exceeded the failure limit.
Comment 46 Build Bot 2017-09-09 22:03:09 PDT
Created attachment 320378 [details]
Archive of layout-test-results from ews100 for mac-elcapitan

The attached test failures were seen while running run-webkit-tests on the mac-ews.
Bot: ews100  Port: mac-elcapitan  Platform: Mac OS X 10.11.6
Comment 47 Build Bot 2017-09-09 22:06:43 PDT
Comment on attachment 320377 [details]
possible patch for landing

Attachment 320377 [details] did not pass mac-wk2-ews (mac-wk2):
Output: http://webkit-queues.webkit.org/results/4501481

Number of test failures exceeded the failure limit.
Comment 48 Build Bot 2017-09-09 22:06:45 PDT
Created attachment 320379 [details]
Archive of layout-test-results from ews105 for mac-elcapitan-wk2

The attached test failures were seen while running run-webkit-tests on the mac-wk2-ews.
Bot: ews105  Port: mac-elcapitan-wk2  Platform: Mac OS X 10.11.6
Comment 49 Build Bot 2017-09-09 22:16:34 PDT
Comment on attachment 320377 [details]
possible patch for landing

Attachment 320377 [details] did not pass mac-debug-ews (mac):
Output: http://webkit-queues.webkit.org/results/4501498

Number of test failures exceeded the failure limit.
Comment 50 Build Bot 2017-09-09 22:16:36 PDT
Created attachment 320380 [details]
Archive of layout-test-results from ews115 for mac-elcapitan

The attached test failures were seen while running run-webkit-tests on the mac-debug-ews.
Bot: ews115  Port: mac-elcapitan  Platform: Mac OS X 10.11.6
Comment 51 Build Bot 2017-09-09 22:31:27 PDT
Comment on attachment 320377 [details]
possible patch for landing

Attachment 320377 [details] did not pass ios-sim-ews (ios-simulator-wk2):
Output: http://webkit-queues.webkit.org/results/4501512

Number of test failures exceeded the failure limit.
Comment 52 Build Bot 2017-09-09 22:31:29 PDT
Created attachment 320381 [details]
Archive of layout-test-results from ews125 for ios-simulator-wk2

The attached test failures were seen while running run-webkit-tests on the ios-sim-ews.
Bot: ews125  Port: ios-simulator-wk2  Platform: Mac OS X 10.12.5
Comment 53 Filip Pizlo 2017-09-10 09:59:23 PDT
Created attachment 320396 [details]
possible patch for landing

Boy, getting these line/column heuristics right is tough.

Turns out that ScriptCallStackFactory does need to handle the case where column isn't set.
Comment 54 Filip Pizlo 2017-09-10 11:03:49 PDT
Created attachment 320398 [details]
possible patch for landing

Cleaned things up more
Comment 55 Filip Pizlo 2017-09-10 12:00:26 PDT
Landed in https://trac.webkit.org/changeset/221836/webkit
Comment 56 Ryan Haddad 2017-09-18 12:22:55 PDT
This change appears to have introduced a large number of memory leaks: https://build.webkit.org/builders/Apple%20Sierra%20%28Leaks%29/builds/3097

I can't get the leaks viewer to work for this build and the ones after it (I guess the log is too large?). Here is a link to download the results: https://build.webkit.org/results/Apple%20Sierra%20%28Leaks%29/r221836%20%283097%29.zip
Comment 57 Yusuke Suzuki 2017-09-18 12:27:21 PDT
(In reply to Ryan Haddad from comment #56)
> This change appears to have introduced a large number of memory leaks:
> https://build.webkit.org/builders/Apple%20Sierra%20%28Leaks%29/builds/3097
> 
> I can't get the leaks viewer to work for this build and the ones after it (I
> guess the log is too large?). Here is a link to download the results:
> https://build.webkit.org/results/Apple%20Sierra%20%28Leaks%29/
> r221836%20%283097%29.zip

I think we should have ErrorInstance::destroy to call ~ErrorInstance.
Comment 58 Filip Pizlo 2017-09-18 12:29:55 PDT
(In reply to Yusuke Suzuki from comment #57)
> (In reply to Ryan Haddad from comment #56)
> > This change appears to have introduced a large number of memory leaks:
> > https://build.webkit.org/builders/Apple%20Sierra%20%28Leaks%29/builds/3097
> > 
> > I can't get the leaks viewer to work for this build and the ones after it (I
> > guess the log is too large?). Here is a link to download the results:
> > https://build.webkit.org/results/Apple%20Sierra%20%28Leaks%29/
> > r221836%20%283097%29.zip
> 
> I think we should have ErrorInstance::destroy to call ~ErrorInstance.

Yeah, I just saw that.  Working on a patch.
Comment 59 Filip Pizlo 2017-09-18 15:41:39 PDT
(In reply to Ryan Haddad from comment #56)
> This change appears to have introduced a large number of memory leaks:
> https://build.webkit.org/builders/Apple%20Sierra%20%28Leaks%29/builds/3097
> 
> I can't get the leaks viewer to work for this build and the ones after it (I
> guess the log is too large?). Here is a link to download the results:
> https://build.webkit.org/results/Apple%20Sierra%20%28Leaks%29/
> r221836%20%283097%29.zip

Should be fixed in https://trac.webkit.org/changeset/222186/webkit
Comment 60 Radar WebKit Bug Importer 2017-09-27 12:36:56 PDT
<rdar://problem/34693606>